<?php

namespace App\Http\Controllers\Admin;

use App\About;
use App\AboutDescription;
use App\Http\Requests\AboutRequest;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use Illuminate\Http\RedirectResponse;

class AboutController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath = '/admin/abouts';
    /** View folder */
    private $viewDirectory = 'admin.abouts.';

    public function __construct()
    {
        $this->redirectSuccessPath = getCurrentLocale().$this->redirectSuccessPath;
    }
    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('abouts.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index', get_defined_vars());
    }

    /**
     * return data of the abouts.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = About::orderBy('abouts.id', 'DESC')
            ->join('about_descriptions AS aboutDesc', 'abouts.id', 'aboutDesc.about_id')
            ->join('languages', 'languages.id', 'aboutDesc.language_id')
            ->where('aboutDesc.language_id', currentLanguage()->id)
            ->select(['aboutDesc.about_title', 'abouts.*']);

        if ($request->date_from) {
            $query->whereDate('abouts.created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('abouts.created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('aboutDesc.title', 'LIKE', '%'.$request->name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $abouts= $query->cursor();

        return view($this->viewDirectory.'grid', get_defined_vars());
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create()
    {
        return redirect()->route('pages.index');
//        $action= route('abouts.store');
//        $head = metaFields('abouts', 'add_new', getCurrentLocale()) ?? __('abouts.new');
//        return view( $this->viewDirectory.'form', get_defined_vars('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param About $request
     * @return RedirectResponse|Redirector
     */
    public function store(AboutRequest $request) :RedirectResponse
    {
        $data = $request->all();
        $data['video_url'] = parseExternalVideoLink($request->video_url)['url'];
        $abouts = About::create($data);
        // Insert Description
        $this->saveData( $request, $abouts->id );

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param About $about
     * @return View
     */
    public function edit(About $about) :View
    {
        $action= route('abouts.update', $about->id);
        $head = metaFields('abouts', 'edit', getCurrentLocale()) ?? __('abouts.edit');
        $title = $head;

        $query = AboutDescription::where('about_id', $about->id)
            ->join('languages', 'languages.id', 'about_descriptions.language_id')
            ->select(['about_descriptions.*', 'languages.local']);

        $aboutDescription= $query->get();

        foreach ($aboutDescription as $row) {
            $about[$row->local]= $row;
        }

        return view( $this->viewDirectory.'form', get_defined_vars() );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param AboutRequest $request
     * @param About $about
     * @return JsonResponse
     */
    public function update(AboutRequest $request, About $about) :JsonResponse
    {
        $data = $request->all();
        $data['video_url'] = parseExternalVideoLink($request->video_url)['url'];
        $about->update($data);
        AboutDescription::where('about_id', $about->id)->delete();
        $this->saveData( $request, $about->id );
        session()->flash('message', __('dashboard.saveDone'));
        return response()->json(['url' => route('abouts.index')]);
//        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Handle Save form data
     *
     * @param AboutRequest $request
     * @param int $about_id
     * @return void
     */

    private function saveData(AboutRequest $request, int $about_id ):void
    {
        $requestData= $request->all();

        foreach (languages() as $lang) {
            $data=[
                'about_title'=> $requestData['about_title_'.$lang->local],
                'vision_title'=> $requestData['vision_title_'.$lang->local],
                'mission_title'=> $requestData['mission_title_'.$lang->local],
                'message_title'=> $requestData['message_title_'.$lang->local],
                'video_title'=> $requestData['video_title_'.$lang->local],
                'client_title'=> $requestData['client_title_'.$lang->local],
                'cases_title'=> $requestData['cases_title_'.$lang->local],
                'consulting_title'=> $requestData['consulting_title_'.$lang->local],
                'documentation_title'=> $requestData['documentation_title_'.$lang->local],
                'achieve_title'=> $requestData['achieve_title_'.$lang->local],
                'about_description'=> $requestData['about_description_'.$lang->local],
                'video_description'=> $requestData['video_description_'.$lang->local],
                'vision_description'=> $requestData['vision_description_'.$lang->local],
                'mission_description'=> $requestData['mission_description_'.$lang->local],
                'message_description'=> $requestData['message_description_'.$lang->local],
                'achieve_description'=> $requestData['achieve_description_'.$lang->local],
                'slug'=> $requestData['slug_'.$lang->local],
                'keywords'=> $requestData['keywords_'.$lang->local],
                'meta_description'=> $requestData['meta_description_'.$lang->local],
                'about_id'=> $about_id,
                'language_id'=> $lang->id,
            ];
            AboutDescription::create($data);
        }

    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $abouts = About::withTrashed()->find($id);
        if ($abouts) {
            if ($abouts->deleted_at) {
                $abouts->forceDelete();
            } else {
                $abouts->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several abouts by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            About::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            About::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $abouts = About::withTrashed()->find($id);

        if ($abouts){
            $abouts->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several abouts by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $abouts = About::whereIn('id', $request->ids)->onlyTrashed();
        if ($abouts){
            $abouts->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
